/*
 *  Copyright (c) 2014 Stefan Taferner <stefan.taferner@gmx.at>
 *                2015 Deti Fliegl <deti@fliegl.de>
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License version 3 as
 *  published by the Free Software Foundation.
 */

//#include <sblib/core.h>
//#include <sblib/eib/sblib_default_objects.h>    /* Manuel */

#include "app_4sense.h"

//#include <sblib/eib.h>
//#include <sblib/timeout.h>
#include <string.h>

#include "channel.h"
//#include "sensor.h"

Channel * channelObjs[MAX_CHANNELS];
unsigned int num_hum=0;

SensorTemp st;
SensorHum sh[MAX_CHANNELS];

/* process received write_value_request telegramm
   unused, objects cannot be written */
void objectUpdated(int objno)
{
}

void checkPeriodic(void)
{
	st.read();           // read all sensors physically
    for (uint8_t i = 0; i < num_hum; i++)
    {
    	sh[i].read();    // read all sensors physically
    }
    for (uint8_t i = 0; i < MAX_CHANNELS; i++)
    {
    	if (channelObjs[i])
    	{
    	    channelObjs[i]->read();		       // read from sensor object and update
    	    channelObjs[i]->checkPeriodic();   // check thresholds and difference, send if necessary
    	}
    }
}

void initApplication(void)
{
    uint8_t  ch, cht=0, chh=0;

    // Create new sensor and channel objects
    for (ch = 0; ch < MAX_CHANNELS; ch++)
    {
        uint8_t channelType = userEeprom.getUInt8(SENSOR_TYPE+ch);

        switch (channelType)
        {
        case 1:                // temperature sensor, cht is instance
        	if (cht == 0)
        	{
        	    st.Setup();	   // initialize one temp sensor object for multiple sensors
        	}
        	channelObjs[ch] = new Channel(TYPE_TEMP, ch, &st, cht++);
        	break;
        case 2:                // humidity sensor
      	    sh[chh].Setup(chh);    // initialize one hum sensor object for one sensor
        	channelObjs[ch] = new Channel(TYPE_HUM, ch, &sh[chh], chh++);
        	num_hum++;
        	break;
        case 4:
        	// VOC via I2C
        	break;
        default:
        	channelObjs[ch] = NULL;
        }
    }
}
