/*
 *  Low level abstraction for sensors
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License version 3 as
 *  published by the Free Software Foundation.
 */

#ifndef SENSOR_H_
#define SENSOR_H_

#include <sblib/core.h>

#include <sblib/sensors/ds18x20.h>
#include <sblib/sensors/dht.h>

#define MAX_CHANNELS 4

class Sensor
{
public:
    void Setup(void) {};
    virtual bool read(void);
    virtual signed int getValue(unsigned int channel);
    unsigned int getNum();
protected:
    unsigned int noOfChannels;         // number of values per channel
    unsigned int inputState;
};

class SensorTemp : public Sensor
{
public:
	void Setup(void);
    virtual bool read(void);
    virtual signed int getValue(unsigned int channel);
protected:
	DS18x20 ds;
	bool bInitSearch;     // Device search state
};


class SensorHum : public Sensor
{
public:
	void Setup(unsigned int id);
    virtual bool read(void);
    virtual signed int getValue(unsigned int channel);
protected:
	DHT dht;
};


#endif /* SENSOR_H_ */
